#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;

#endregion



#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		
		private BetterVolume[] cacheBetterVolume;

		
		public BetterVolume BetterVolume(int lookback, bool use2bars, bool paintbars, bool useTrueRange, bool useTickVolume)
		{
			return BetterVolume(Input, lookback, use2bars, paintbars, useTrueRange, useTickVolume);
		}


		
		public BetterVolume BetterVolume(ISeries<double> input, int lookback, bool use2bars, bool paintbars, bool useTrueRange, bool useTickVolume)
		{
			if (cacheBetterVolume != null)
				for (int idx = 0; idx < cacheBetterVolume.Length; idx++)
					if (cacheBetterVolume[idx].Lookback == lookback && cacheBetterVolume[idx].Use2bars == use2bars && cacheBetterVolume[idx].Paintbars == paintbars && cacheBetterVolume[idx].UseTrueRange == useTrueRange && cacheBetterVolume[idx].UseTickVolume == useTickVolume && cacheBetterVolume[idx].EqualsInput(input))
						return cacheBetterVolume[idx];
			return CacheIndicator<BetterVolume>(new BetterVolume(){ Lookback = lookback, Use2bars = use2bars, Paintbars = paintbars, UseTrueRange = useTrueRange, UseTickVolume = useTickVolume }, input, ref cacheBetterVolume);
		}

	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		
		public Indicators.BetterVolume BetterVolume(int lookback, bool use2bars, bool paintbars, bool useTrueRange, bool useTickVolume)
		{
			return indicator.BetterVolume(Input, lookback, use2bars, paintbars, useTrueRange, useTickVolume);
		}


		
		public Indicators.BetterVolume BetterVolume(ISeries<double> input , int lookback, bool use2bars, bool paintbars, bool useTrueRange, bool useTickVolume)
		{
			return indicator.BetterVolume(input, lookback, use2bars, paintbars, useTrueRange, useTickVolume);
		}
	
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		
		public Indicators.BetterVolume BetterVolume(int lookback, bool use2bars, bool paintbars, bool useTrueRange, bool useTickVolume)
		{
			return indicator.BetterVolume(Input, lookback, use2bars, paintbars, useTrueRange, useTickVolume);
		}


		
		public Indicators.BetterVolume BetterVolume(ISeries<double> input , int lookback, bool use2bars, bool paintbars, bool useTrueRange, bool useTickVolume)
		{
			return indicator.BetterVolume(input, lookback, use2bars, paintbars, useTrueRange, useTickVolume);
		}

	}
}

#endregion
